<template>
  <div class="lighting-page fixed inset-0">
    <Header title="Lighting" :onBack="backToMain" />

    <div class="main pt-[106px]">
      <div class="h-[36px] px-4 text-right">
        <span class="font-semibold text-xl">ออกรายงาน</span>
      </div>

      <div
        style="height: calc(100vh - 142px)"
        class="p-4 grid grid-cols-4 grid-rows-3 gap-4"
      >
        <LightingMap
          :map_data="light_data"
          :selected_place="selected_place"
          :selectPlace="selectPlace"
          class="col-span-2 row-span-3"
        />

        <div
          class="rounded-md p-4 bg-darkblue border-primary border overflow-auto"
        >
          <LightingSystem :system_data="system_data" />
        </div>

        <div
          class="rounded-md p-4 bg-darkblue border-primary border overflow-auto"
        >
          <LightingTotalEnery
            :total_energy="total_energy"
            :light_data="light_data"
          />
        </div>

        <div
          class="rounded-md p-4 pb-0 bg-darkblue border-primary border row-span-2"
        >
          <LightingGroupList
            :group_data="group_data"
            :light_data="light_data"
            :selected_group="selected_group"
            :selectGroup="selectGroup"
            :addGroup="addGroup"
            :editGroup="editGroup"
            :switchGroupLight="switchGroupLight"
          />
        </div>

        <div
          class="rounded-md p-4 pb-0 bg-darkblue border-primary border row-span-2"
        >
          <LightingList
            :light_data="display_light_data"
            :selected_group="selected_group"
            :selectGroup="selectGroup"
            :editLight="editLight"
            :switchLight="switchLight"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import _ from "lodash";

export default {
  data() {
    return {
      selected_place: {},
      selected_group: {},
      light_data: [
        {
          id: 1,
          name: "Light001",
          status: true,
          hour: 8519,
          energy: 2101,
          date: "Apr 26",
          time: "12:00",
          light_step: 100,
          time_list: [
            {
              open: "",
              close: "",
            },
            {
              open: "",
              close: "",
            },
          ],
          group: {
            id: 1,
            name: "หาดพลา",
          },
          position: {
            name: "หาดพยูน",
            lat: 13.736717,
            lng: 100.523186,
            address: "ถนนเทศบาล 46 ตำบลบ้านฉาง  อำเภอบ้านฉาง จังหวัดระยอง",
          },
          statistic: {
            energy_data: [
              {
                value: 210,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 310,
                date: "Apr 27",
                time: "12:00",
              },
              {
                value: 510,
                date: "Apr 28",
                time: "12:00",
              },
            ],
            intensity_data: [
              {
                value: 210,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 210,
                date: "Apr 27",
                time: "12:00",
              },
            ],
          },
          changing_list: [
            {
              name: "dasdas",
              datetime: "2009-06-15T13:45:30",
            },
          ],
        },
        {
          id: 2,
          name: "Light002",
          status: true,
          hour: 8519,
          energy: 5101,
          date: "Apr 26",
          time: "12:00",
          light_step: 100,
          time_list: [
            {
              open: "",
              close: "",
            },
            {
              open: "",
              close: "",
            },
          ],
          group: {
            id: 2,
            name: "หาดพลา2",
          },
          position: {
            name: "หาดพยูน",
            lat: 13.6626,
            lng: 100.4375,
            address: "ถนนเทศบาล 46 ตำบลบ้านฉาง  อำเภอบ้านฉาง จังหวัดระยอง",
          },
          statistic: {
            energy_data: [
              {
                value: 210,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 210,
                date: "Apr 27",
                time: "12:00",
              },
            ],
            intensity_data: [
              {
                value: 210,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 210,
                date: "Apr 27",
                time: "12:00",
              },
            ],
          },
          changing_list: [
            {
              name: "dsdasd",
              datetime: "2009-06-15T13:45:30",
            },
          ],
        },
        {
          id: 3,
          name: "Light003",
          status: true,
          hour: 8519,
          energy: 10101,
          date: "Apr 26",
          time: "12:00",
          light_step: 100,
          time_list: [
            {
              open: "",
              close: "",
            },
            {
              open: "",
              close: "",
            },
          ],
          group: {
            id: 2,
            name: "หาดพลา2",
          },
          position: {
            name: "หาดพยูน",
            lat: 13.6626,
            lng: 100.4375,
            address: "ถนนเทศบาล 46 ตำบลบ้านฉาง  อำเภอบ้านฉาง จังหวัดระยอง",
          },
          statistic: {
            energy_data: [
              {
                value: 210,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 210,
                date: "Apr 27",
                time: "12:00",
              },
            ],
            intensity_data: [
              {
                value: 210,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 510,
                date: "Apr 27",
                time: "12:00",
              },
            ],
          },
          changing_list: [
            {
              name: "dsadsa",
              datetime: "2009-06-15T13:45:30",
            },
          ],
        },
      ],
      total_energy: 21234,
      system_data: {
        open: 20,
        close: 9,
      },
      group_data: [
        {
          id: 1,
          name: "หาดพลา",
          status: true,
          light_step: 100,
          active_list: ["Light001", "Light002"],
          time_list: [
            {
              open: "",
              close: "",
            },
            {
              open: "",
              close: "",
            },
          ],
        },
        {
          id: 2,
          name: "หาดพลา2",
          status: true,
          light_step: 100,
          active_list: ["Light001", "Light002"],
          time_list: [
            {
              open: "",
              close: "",
            },
            {
              open: "",
              close: "",
            },
          ],
        },
      ],
    };
  },
  computed: {
    display_light_data() {
      return this.selected_group.id
        ? _.filter(
            this.light_data,
            (d) => d.group.id === this.selected_group.id
          )
        : this.light_data;
    },
  },
  methods: {
    selectPlace(place) {
      this.selected_place = place;
    },
    selectGroup(group) {
      this.selected_group = this.selected_group.id === group.id ? {} : group;
    },
    async addGroup(group) {
      // try {
      //   const res = await this.$appApi.$post(`/endpoint`, {});
      // } catch (error) {
      //   console.log(error);
      // }

      this.group_data.push(group);
    },
    editGroup(group) {
      const index = _.findIndex(this.group_data, (d) => d.id === group.id);
      this.group_data[index] = group;
    },
    editLight(light) {
      const index = _.findIndex(this.light_data, (d) => d.id === light.id);
      this.light_data[index] = light;
    },
    switchGroupLight(group) {
      _.forEach(this.light_data, (d) => {
        if (d.group.id === group.id) d.status = group.status;
      });
    },
    switchLight(light) {
      console.log(light);
    },
    backToMain() {},
  },
};
</script>

<style lang="scss" scoped></style>
